/**
 * @file
 * 'n1ed' plugin admin behavior.
 */

if (!window.n1edEcoControlPanelLoaded) {

    window.n1edEcoControlPanelLoaded = true;

    var elFieldSet = document.getElementById("editor-settings-wrapper");
    var elConf = document.createElement("div");
    elFieldSet.parentElement.insertBefore(elConf, elFieldSet);

    elConf.innerHTML = '<div id="n1ed-eco-wrap" style="border: 1px solid #c0c0c0; margin: 1em 0; padding: 18px; border-radius: 2px; background-color: #fcfcfa">' +

        '<div style="display:flex;align-items: center">' +
            '<img' +
                 ' style="flex: 0 0 280px;border: 3px solid #BBB;transform: perspective(1200px) rotateY(25deg) rotateX(8deg) scale(0.9);box-shadow: -22px 12px 0 rgba(0, 0, 0, 0.1);margin: 22px 25px 26px 23px;"' +
                 ' src="https://n1ed.com/img/dashboard/dashboard-mini.png"/>' +

            '<div style="flex: 1 1 100%">' +

                '<!--<div style="letter-spacing: 0.08em; text-transform: uppercase; font-size: 1em; font-weight: bold;">N1ED configuration</div>-->' +

                '<style>' +
                    '.n1ed-d8-checkbox-wrap { display: flex; justify-content: left; align-items: center}' +
                    '.n1ed-d8-checkbox-text { flex: 1 1 100%; font-size: 15px; font-weight: bold; margin-top: 2px; }' +
                    '.n1ed-d8-checkbox { cursor: pointer; flex: 0 0 56px; box-sizing: border-box; margin-right: 14px; height: 28px; border-radius: 32px; background-color: #636363; padding: 3px; position: relative; }' +
                    '.n1ed-d8-checkbox:hover { background-color: #777; }' +
                    '.n1ed-d8-checkbox > div { width: 24px; height: 24px; border-radius: 13px; background-color: white; position: absolute; top: 2px; left: 2px; }' +
                    '.n1ed-d8-checkbox--selected { background-color: #00d400; }' +
                    '.n1ed-d8-checkbox--selected:hover { background-color: #00e400; }' +
                    '.n1ed-d8-checkbox--selected > div { left: 30px }' +
                    '.n1ed-eco-wrap--disabled { color: #888; }' +
                    '.n1ed-eco-wrap--disabled .button { pointer-events: none; cursor: default; color: white; background-image: none; text-shadow: none; background-color: #DDD; border-color: #DDD; }' +
                    '.n1ed-eco-wrap--disabled .n1ed-d8-checkbox-text { color: black; }' +
                    '#n1ed-eco-button:before { content: ""; width: 160px; left: -170px; border-top: 2px #94c9ff solid; position: absolute; top: 11px; }' +
                    '#n1ed-eco-button:after { content: ""; width: 8px; height: 8px; border-radius: 100%; background-color: #94c9ff; position: absolute; top: 8px; left: -172px; }' +
                    '.n1ed-eco-wrap--disabled #n1ed-eco-button:before { border-color: #DDD; }' +
                    '.n1ed-eco-wrap--disabled #n1ed-eco-button:after { background-color: #DDD; }' +
                    '.n1ed-eco-wrap--disabled code { color: #888 !important; border-color: #888 !important; }' +
                    '.n1ed-eco-wrap--disabled a { color: #AAA; pointer-events: none; }' +
                    '.n1ed-eco-wrap--disabled img { opacity: 0.6; }' +
                '</style>' +

                '<div class="n1ed-d8-checkbox-wrap">' +
                    '<div class="n1ed-d8-checkbox n1ed-d8-checkbox--selected" id="n1ed-eco-checkbox"><div></div></div>' +
                    '<div class="n1ed-d8-checkbox-text">Use N1ED in this text format</div>' +
                '</div>' +

                '<p style="max-width: 800px;">Your N1ED add-on for CKEditor is linked to API key <code style="border: 2px solid #007FFF; color: #007FFF; padding: 4px 7px; margin: 0 4px 0 2px;">' + window.drupalSettings.n1edApiKey + '</code> <a href="/admin/config/content/n1ed" target="_blank">Change...</a></p>' +

                (
                    (["N1D8", "N1ED"].indexOf(window.drupalSettings.n1edApiKey.substr(0, 4).toUpperCase()) > -1)
                    ?
                    '<p style="max-width: 800px;">This is <i>shared</i> API key. You can continue using it, but in order to configure N1ED you need to obtain your own API key for free.</p>'
                    :
                    ''
                ) +

                '<p style="max-width: 800px;">Configuration applies to all N1ED Ecosystem add-ons: N1ED, Bootstrap Editor, File Manager and other plugins you can enable from this dashboard. N1ED stores configuration on own server and using the power of CDN received both configuration and updates on the fly.</p>' +

                '<a id="n1ed-eco-button" target="_blank" href="https://n1ed.com/dashboard" class="button button--primary" style="margin:0">Configure N1ED Ecosystem</a>' +

            '</div>' +

        '</div>' +

    '</div>';


    var elCheckbox = document.getElementById("n1ed-eco-checkbox"); console.log(elCheckbox);
    var elInput = document.querySelector("[data-n1ed-eco-param-name=\"enableN1EDEcoSystem\"]");
    var elWrap = document.getElementById("n1ed-eco-wrap");
    elCheckbox.classList.toggle("n1ed-d8-checkbox--selected", elInput.value !== "false");
    elCheckbox.addEventListener("click", function() {
        elCheckbox.classList.toggle("n1ed-d8-checkbox--selected");
        var isOn = elCheckbox.classList.contains("n1ed-d8-checkbox--selected");
        elInput.value = isOn ? "true" : "false";
        elWrap.classList.toggle("n1ed-eco-wrap--disabled", !isOn);
    });

}